﻿Imports System.IO
Imports System.Text
Imports System.Data
Imports System.Drawing
Imports System.Data.SqlClient
Imports System.Configuration
Imports iTextSharp.text
Imports iTextSharp.text.pdf
Imports iTextSharp.tool.xml

Partial Class VB
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        If Not IsPostBack Then
            Me.BindGrid()
        End If
    End Sub

    Private Sub BindGrid()
        Dim constr As String = ConfigurationManager.ConnectionStrings("constr").ConnectionString
        Using con As New SqlConnection(constr)
            Using cmd As New SqlCommand("SELECT * FROM Customers")
                Using sda As New SqlDataAdapter()
                    cmd.Connection = con
                    sda.SelectCommand = cmd
                    Using dt As New DataTable()
                        sda.Fill(dt)
                        gvCustomers.DataSource = dt
                        gvCustomers.DataBind()
                    End Using
                End Using
            End Using
        End Using
    End Sub


    Protected Sub OnPageIndexChanging(sender As Object, e As GridViewPageEventArgs)
        gvCustomers.PageIndex = e.NewPageIndex
        Me.BindGrid()
    End Sub

    Protected Sub ExportToWord(ByVal sender As Object, ByVal e As EventArgs)
        Response.Clear()
        Response.Buffer = True
        Response.AddHeader("content-disposition", "attachment;filename=GridViewExport.doc")
        Response.Charset = ""
        Response.ContentType = "application/vnd.ms-word"

        Using sw As StringWriter = New StringWriter()
            Dim hw As HtmlTextWriter = New HtmlTextWriter(sw)

            'To Export all pages.
            gvCustomers.AllowPaging = False
            Me.BindGrid()

            gvCustomers.HeaderRow.BackColor = Color.White
            For Each cell As TableCell In gvCustomers.HeaderRow.Cells
                cell.BackColor = gvCustomers.HeaderStyle.BackColor
            Next

            For Each row As GridViewRow In gvCustomers.Rows
                row.BackColor = Color.White
                For Each cell As TableCell In row.Cells
                    If row.RowIndex Mod 2 = 0 Then
                        cell.BackColor = gvCustomers.AlternatingRowStyle.BackColor
                    Else
                        cell.BackColor = gvCustomers.RowStyle.BackColor
                    End If
                Next
            Next

            gvCustomers.RenderControl(hw)
            Response.Output.Write(sw.ToString())
            Response.Flush()
            Response.End()
        End Using
    End Sub

    Protected Sub ExportToExcel(sender As Object, e As EventArgs)
        Response.Clear()
        Response.Buffer = True
        Response.AddHeader("content-disposition", "attachment;filename=GridViewExport.xls")
        Response.Charset = ""
        Response.ContentType = "application/vnd.ms-excel"
        Using sw As New StringWriter()
            Dim hw As New HtmlTextWriter(sw)

            'To Export all pages.
            gvCustomers.AllowPaging = False
            Me.BindGrid()

            gvCustomers.HeaderRow.BackColor = Color.White
            For Each cell As TableCell In gvCustomers.HeaderRow.Cells
                cell.BackColor = gvCustomers.HeaderStyle.BackColor
            Next
            For Each row As GridViewRow In gvCustomers.Rows
                row.BackColor = Color.White
                For Each cell As TableCell In row.Cells
                    If row.RowIndex Mod 2 = 0 Then
                        cell.BackColor = gvCustomers.AlternatingRowStyle.BackColor
                    Else
                        cell.BackColor = gvCustomers.RowStyle.BackColor
                    End If
                    cell.CssClass = "textmode"
                Next
            Next

            gvCustomers.RenderControl(hw)

            'Style to format numbers to string.
            Dim style As String = "<style> .textmode { mso-number-format:\@; } </style>"
            Response.Write(style)
            Response.Output.Write(sw.ToString())
            Response.Flush()
            Response.End()

        End Using
    End Sub

    Protected Sub ExportToPDF(ByVal sender As Object, ByVal e As EventArgs)
        Response.Clear()
        Response.Buffer = True
        Response.AddHeader("content-disposition", "attachment;filename=GridViewExport.pdf")
        Response.Charset = ""
        Response.ContentType = "application/pdf"

        'To Export all pages.
        gvCustomers.AllowPaging = False
        Me.BindGrid()

        Using sw As StringWriter = New StringWriter()
            Using hw As HtmlTextWriter = New HtmlTextWriter(sw)
                gvCustomers.RenderControl(hw)
                Using sr As StringReader = New StringReader(sw.ToString())
                    Using pdfDoc As Document = New Document(PageSize.A4, 10.0F, 10.0F, 10.0F, 0.0F)
                        Using writer As PdfWriter = PdfWriter.GetInstance(pdfDoc, Response.OutputStream)
                            pdfDoc.Open()
                            XMLWorkerHelper.GetInstance().ParseXHtml(writer, pdfDoc, sr)
                            pdfDoc.Close()
                            Response.Cache.SetCacheability(HttpCacheability.NoCache)
                            Response.Write(pdfDoc)
                            Response.End()
                        End Using
                    End Using
                End Using
            End Using
        End Using
    End Sub

    Protected Sub ExportToCSV(ByVal sender As Object, ByVal e As EventArgs)
        Response.Clear()
        Response.Buffer = True
        Response.AddHeader("content-disposition", "attachment;filename=GridViewExport.csv")
        Response.Charset = ""
        Response.ContentType = "text/csv"
        gvCustomers.AllowPaging = False
        Me.BindGrid()
        Dim sb As StringBuilder = New StringBuilder()

        For Each cell As TableCell In gvCustomers.HeaderRow.Cells
            'Append data with separator.
            sb.Append(cell.Text & ",")
        Next

        'Append new line character.
        sb.Append(vbCr & vbLf)

        For Each row As GridViewRow In gvCustomers.Rows
            For Each cell As TableCell In row.Cells
                'Append data with separator.
                sb.Append(cell.Text & ",")
            Next
            'Append new line character.
            sb.Append(vbCr & vbLf)
        Next

        Response.Output.Write(sb.ToString())
        Response.Flush()
        Response.End()
    End Sub

    Public Overrides Sub VerifyRenderingInServerForm(control As Control)
        ' Verifies that the control is rendered
    End Sub
End Class

